﻿
Module Module_SendKeys

    ' https://docs.microsoft.com/en-us/dotnet/api/system.windows.forms.sendkeys?view=netframework-3.5

    Friend Function GetSendKeysNames() As String
        GetSendKeysNames = " {SHIFT} {CTRL} {ALT} {WINDOWS} " + _
                           "{TAB} {ESC} {ENTER} {LEFT} {RIGHT} {UP} {DOWN} " + _
                           "{BACKSPACE} {BREAK} {CAPSLOCK} {PGUP} {PGDN} " + _
                           "{END} {HOME} {PRTSC} {INSERT} {DELETE} {SCROLLLOCK} {NUMLOCK} {HELP} " + _
                           "{ADD} {SUBTRACT} {MULTIPLY} {DIVIDE} " + _
                           ": ; = , <  > _ . ? * - / ~ ` [ { \ | ] } ' " + _
                           "a b c d e f g h i j k l m n o p q r s t u v w x y z " + _
                           "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z " + _
                           "0 1 2 3 4 5 6 7 8 9 " + _
                           "{F1} {f2} {f3} {f4} {f5} {f6} {f7} {f8} {f9} {f10} {f11} {f12} "
    End Function

    Friend Function GetSendKeysNames_NoLetters() As String
        GetSendKeysNames_NoLetters = " {SHIFT} {CTRL} {ALT} {WINDOWS} " + _
                                     "{TAB} {ESC} {ENTER} {LEFT} {RIGHT} {UP} {DOWN} " + _
                                     "{BACKSPACE} {BREAK} {CAPSLOCK} {PGUP} {PGDN} " + _
                                     "{END} {HOME} {PRTSC} {INSERT} {DELETE} {SCROLLLOCK} {NUMLOCK} {HELP} " + _
                                     "{ADD} {SUBTRACT} {MULTIPLY} {DIVIDE} " + _
                                     ": ; = , <  > _ . ? * - / ~ ` [ { \ | ] } ' " + _
                                     "0 1 2 3 4 5 6 7 8 9 " + _
                                     "{F1} {f2} {f3} {f4} {f5} {f6} {f7} {f8} {f9} {f10} {f11} {f12} "
    End Function

    Friend Sub ExecuteSendKeys(ByVal str As String)
        str = str.Replace("{WINDOWS}", "^{ESC}")
        str = str.Replace("{SHIFT}", "+")
        str = str.Replace("{CTRL}", "^")
        str = str.Replace("{ALT}", "%")
        Try
            SendKeys.SendWait(str)
        Catch
        End Try
    End Sub

End Module
